obj
{

	New()
	{
		..();
		#ifdef DYNAMIC_ICONS
		enviro_state=icon_state;
		#endif
	}

	#ifdef DYNAMIC_ICONS
	#ifdef SEASONAL_LOOP
	proc
	{
		enviro_GetStateNum(state)
		{
			if(!state)
			{
				state=icon_state;
			}

			return text2num(copytext(state, length(enviro_header_state)+1));
		}

		enviro_GetMaxStateNum()
		{
			var highest = 0;
			for(var/v in icon_states(icon))
			{
				if(enviro_GetStateNum(v) > highest)
				{
					highest = enviro_GetStateNum(v);
				}
			}

			return highest;
		}

		enviro_GetSeasonStart()
		{
			var first_underscore = findtext(icon_state, "_");
			return first_underscore + 1;
		}

		enviro_UpdateWorn()
		{
			if(last_worn_check == walked_on)
			{
				return FALSE;
			}

			var type_header = copytext(icon_state, 1, enviro_GetSeasonStart() - 1);
			var max_state_num = enviro_GetMaxStateNum();
			var state = "[type_header]_[lowertext(season)]_";
			var percent = round(worn_limit * 0.1, 10);

			if(walked_on < percent) // If the walked_on is less than 10% of the worn_limit, make it the highest icon_state
			{
				state += "[max_state_num]";
			}

			if(walked_on >= percent && walked_on < percent*2) //More than or equal to 10%, less than 20%.
			{
				state += "[max_state_num-1]";
			}

			if(walked_on >= percent*2 && walked_on < percent*3) //More than or equal to 20%, less than 30%.
			{
				state += "[max_state_num-2]";
			}

			if(walked_on >= percent*3 && walked_on < percent*4) //More than or equal to 30%, less than 40%.
			{
				state += "[max_state_num-3]";
			}

			if(walked_on >= percent*4 && walked_on < percent*5) //More than or equal to 40%, less than 50%.
			{
				state += "[max_state_num-4]";
			}

			if(walked_on >= percent*5 && walked_on < percent*6) //More than or equal to 50%, less than 60%.
			{
				state += "[max_state_num-5]";
			}

			if(walked_on >= percent*6 && walked_on < percent*7) //More than or equal to 60%, less than 70%.
			{
				state += "[max_state_num-6]";
			}

			if(walked_on >= percent*7 && walked_on < percent*8) //More than or equal to 70%, less than 80%.
			{
				state += "[max_state_num-7]";
			}

			if(walked_on >= percent*8 && walked_on < percent*9) //More than or equal to 80%, less than 90%.
			{
				state += "[max_state_num-8]";
			}

			if(walked_on >= percent*9 && walked_on < percent*10) //More than or equal to 90%, less than 100%.
			{
				state += "[max_state_num-9]";
			}

			if(walked_on >= percent*10) //More than or equal to 100%.
			{
				state += "[max_state_num-10]";
			}

			icon_state = state

			last_worn_check = walked_on
		}
	}
	#endif
	#endif

	#ifdef SHOW_EXAMPLES
	grass
	{
		icon_state = "grass_summer_10";
		#ifdef DYNAMIC_ICONS
		worn_limit = 100;
		regen_wait = 300; // It takes 30 seconds to start regenerating.  Makes for slow grass growth.

		var
		{
			direction = TRUE; //TRUE is up, FALSE is down
		}

		#endif

		New()
		{
			. = ..();
			#ifdef DYNAMIC_ICONS
			enviro_header_state = "grass_summer_";
			#endif
		}

		base_EventCycle()
		{
			..();
			#ifdef DYNAMIC_ICONS
			#ifdef SEASONAL_LOOP
			enviro_UpdateWorn();

			if(walked_on)
			{
				if(world.time >= last_walked_on+regen_wait)
				{
					if(last_regen+regen_wait < world.time)
					{
						walked_on --;
						last_regen = world.time
					}
				}
			}
			#endif
			#endif


		}
		#ifdef DYNAMIC_ICONS
		#ifdef SEASONAL_LOOP
		enviro_Season(s)
		{
			var type_header = copytext(icon_state, 1, enviro_GetSeasonStart() - 1);
			var state_number = enviro_GetStateNum();
			enviro_header_state = "[type_header]_[lowertext(s)]_";
			icon_state = "[type_header]_[lowertext(s)]_[state_number]";
		}
		#endif
		#endif

	}
	#endif

}